#!/usr/bin/env python
import sys
sys.path
sys.path.append('gui')
sys.path.append('card_functions')
sys.path.append('extraction_utils')
import socket               # Import socket module
import json
import basic_functions
import gcode_parser as gparser

soc = socket.socket(socket.AF_INET, socket.SOCK_STREAM)         # Create a socket object
ip_laser = "192.168.16.250"

print "Servidor"

#host = "192.168.1.9"       # Get local machine name
host = "localhost"
port = 2004                # Reserve a port for your service.
soc.bind((host, port))     # Bind to the port

soc.listen(1)                 # Wait for client connection.
conn, addr = soc.accept()     # Establish connection with client.

print "Servidor iniciado:"
print ("Got connection from with",addr)


laser_mach = basic_functions.Connection()  # Create a object

while True:
	msg = conn.recv(1024)		#Recieve message from client		

	protocol = json.loads(msg)	#Load the protocol variable
	if ( protocol["cmd"] == "quit"): 	#Close communication between client and server 
		print("Client has closed.\n")
		conn.send(msg)
		break
	elif (protocol["cmd"] == "connect_to_laser"): #Connects to laser
		print "Connecting machine"
		conn.send(msg)
		laser_mach.beginconn(ip_laser)
		continue
	elif (protocol["cmd"] == "run_perimeter"): #Run the current perimeter indicated by the user in the client
		conn.send(msg)
		msg = conn.recv(1024)
		x = int(msg)
		conn.send(msg)
		msg = conn.recv(1024)
		y = int(msg)
		conn.send(msg)
		laser_mach.runperimeter(x, y, ip_laser)
		continue
   	elif (protocol["cmd"] == "disconnect_laser"): #Close communication between the basic_functions methods and the laser cutter
		print "Disconnect laser"
		laser_mach.endconn()
		continue
	elif (protocol["cmd"] == "run_job"): 	#Run the job specified in gcode 
		conn.send(msg)
		ncfile = conn.recv(1024)
		ncfile = ncfile[:-1]
		print ncfile 
		binfile = gparser.gcinterpreter(ncfile)
		print "Run job"
		laser_mach.sendjob(binfile, ip_laser)
		
		continue
	elif (protocol["cmd"] == "cancel_job"): #Cancel current running job
		print "Cancel job"
		laser_mach.canceljob()
		continue
	elif (protocol["cmd"] == "pause_job"): #Pause current running job
		print "Paused job"
		laser_mach.pause()
		continue
	elif (protocol["cmd"] == "resume_job"): #Resume current runnig job
		print "Resumed job"
		laser_mach.resume()
		continue
	elif (protocol["cmd"] == "moveto"): #Move the laser (turned off) to client's specified position
		conn.send(msg)
		msg = conn.recv(1024)
	        x = int(msg)
	        conn.send(msg)
	        msg = conn.recv(1024)
	        y = int(msg)
	        conn.send(msg)
		laser_mach.jogxy(x, y)
		continue
	else:								#Case: command not found
		print msg
		msg = "Comand not found, try again\n" 
		conn.send(msg)
		msg = conn.recv(1024)
		print msg
		conn.send(msg)
		continue

print "Good Bye\n"
conn.close			
soc.close()		#Close the socket port		

