from collections import deque


#################################################################
# Describes a set of laser movements each one with a given power

class CutterPath(object):

    def __init__(self):
        self.__Queue__ = deque([])

    # Print overload
    def __repr__(self):
        return "{}".format(self.__Queue__)

    # Length of the polygon, how many vectors form the polygon
    def __len__(self):
        return len(self.__Queue__)

    # Set item operator Overload
    def __setitem__(self, key, item):
        self.__Queue__[key] = item

    # Get Item Overload
    def __getitem__(self, key):
        return self.__Queue__[key]

    # Add a vector to the path
    def append(self, vector):
        self.__Queue__.append(vector)

    # Remove a Vector from the path
    def pop(self):
        return self.__Queue__.popleft()
