import svgwrite


######################################################################
# Related to the generation of a job preview
class PreviewGenerator(object):

    def __init__(self, path):
        """
        :param path: The Cut path that will be previewed.
        """
        self.path = path

    def genshowsvg(self, maxdim):
        """
        Generates a file with the name currentjob.svg, similar to the job to execute, this is made
        according to the generated path while extracting, i.e. it is not a simulation of the
        cut commands
        :param maxdim: sets the scale factor to fit the draw int the widget
        """

        # instance to draw the preview
        dwg = svgwrite.Drawing('gui/currentjob.svg~')

        print ('Generating Preview ...\n')

        # Cut points:
        x = []
        y = []

        # Move points:
        mx = []
        my = []

        # constant to change size of draw
        c = 100000./maxdim

        # draw the vectors
        for i in range(len(self.path)):
            current_vector = self.path[i]
            if current_vector.getlaserpower() == 0.0:
                mx.append((current_vector.__StartingPoint__[0]))
                my.append((current_vector.__StartingPoint__[1]))
                mx.append((current_vector.__EndingPoint__[0]))
                my.append((current_vector.__EndingPoint__[1]))

                x = []
                y = []
                mx = []
                my = []

            else:
                x.append((current_vector.__StartingPoint__[0]))
                y.append((current_vector.__StartingPoint__[1]))
                x.append((current_vector.__EndingPoint__[0]))
                y.append((current_vector.__EndingPoint__[1]))
                dwg.add(dwg.line((current_vector.__StartingPoint__[0]*c, current_vector.__StartingPoint__[1]*c),
                                 (current_vector.__EndingPoint__[0]*c, current_vector.__EndingPoint__[1]*c),
                                 stroke=svgwrite.rgb(1, 1, 1, '%'), stroke_width=0.2))

        x = []
        y = []
        mx = []
        my = []
        # save the draw
        dwg.save()
